#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "max_x": 10,
    "max_r":10,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():

    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    max_x = int(cmdlinearg("max_x"))
    max_r = int(cmdlinearg("max_r"))

    print(n)
    for _ in range(n):
        x = random.randint(0, max_x)
        y = random.randint(0, max_x)
        r = random.randint(1, max_r)
        print(x, y, r)


    
    
if __name__ == "__main__":
    main()